using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ch7_5
{
    public partial class Form1 : Form
    {
        private int[] array = new int[10];
        //delegate implementation for ascending sort
        private bool ascedingSort(int e1, int e2)
        {
            return e1 > e2;
        }
        private bool descendingSort(int e1, int e2)
        {
            return e1 < e2;
        }
        private void display()
        {
            textBox2.Clear();
            foreach (int element in array)
            {
                textBox2.Text += element + "\r\n";
            }
        }


        public Form1()
        {
            InitializeComponent();
        }

        private void createButton_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            textBox2.Clear();
            Random num = new Random();
            for (int i = 0; i < array.Length; i++)
            {
                array[i] = num.Next(100);
                textBox1.Text += array[i] + "\r\n";
            }
        }

        private void ascendingButton_Click(object sender, EventArgs e)
        {
            //sort array, passing delegate for ascending sort
            DelegateBubleSort.sortArray(array,
                 new DelegateBubleSort.Comparator(ascedingSort));
            display();
        }

        private void descendingButton_Click(object sender, EventArgs e)
        {
            DelegateBubleSort.sortArray(array,
                 new DelegateBubleSort.Comparator(descendingSort));
            display();

        }

        
    }
}